package com.macd.external;

import java.util.Properties;

import javax.jms.ObjectMessage;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.naming.Context;
import javax.naming.InitialContext;

import com.macd.osgi.bundle.MyOSGI;

/**
 * Message-Driven Bean client class for: MessageDriveBeanTest
 */
public class MessageSender {

    private static void sendMessage() {
        System.out.println( "MessageSender.sendMessage()" );
        QueueConnection queueConnection = null;
        QueueSender sender = null;
        QueueSession session = null;
        InitialContext initialContext;
        try {
            Properties props = new Properties();

//            props.setProperty( "org.omg.CORBA.ORBInitialHost", "localhost" );
//            props.setProperty( "org.omg.CORBA.ORBInitialPort", "10037" );
//            props.setProperty( Context.INITIAL_CONTEXT_FACTORY, "com.sun.enterprise.naming.SerialInitContextFactory" );
            
            System.setProperty( Context.INITIAL_CONTEXT_FACTORY, "com.sun.enterprise.naming.SerialInitContextFactory" );
            System.setProperty( "org.omg.CORBA.ORBInitialHost", "localhost" );
            System.setProperty( "org.omg.CORBA.ORBInitialPort", "3700" );

            initialContext = new InitialContext( props );
            QueueConnectionFactory factory = (QueueConnectionFactory) initialContext.lookup( "ConnectionFactory" );
            Queue queue = (Queue) initialContext.lookup( "queue/MessageDriveBeanOSGI" );
            queueConnection = factory.createQueueConnection( );
            session = queueConnection.createQueueSession( false, QueueSession.AUTO_ACKNOWLEDGE );
            ObjectMessage objectMessage = session.createObjectMessage();
            objectMessage.setObject( new MyOSGI() );
            sender = session.createSender( queue );
            sender.send( objectMessage );
            
            System.out.println( "Message sent successfully to remote queue." );
            System.out.println( "Sent message: " + objectMessage.getObject() );
            System.out.println( "MyOSGI instanceof MyOSGI: " + ( objectMessage.getObject() instanceof MyOSGI ) );
           
            sender.close();
            session.close();
            queueConnection.stop();
            queueConnection.close();
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
    
    
    public static void main( String[] args ) throws Exception {
        System.out.println( "MessageSender.main()" );
        sendMessage();
        System.exit( 0 );
    }

}
