package com.macd.mdb;

import java.io.Serializable;

import javax.ejb.MessageDriven;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;

import com.macd.osgi.bundle.MyOSGI;

/**
 * Message-Driven Bean implementation class for: MessageDriveBeanOSGI
 */
@MessageDriven( name = "MessageDriveBeanOSGI", mappedName = "queue/MessageDriveBeanOSGI" )
public class MessageDriveBeanOSGI
    implements MessageListener {

    /**
     * Default constructor.
     */
    public MessageDriveBeanOSGI() {
        System.out.println();
        System.out.println( "MessageDriveBeanOSGI.MessageDriveBeanOSGI()" );
        System.out.println();
    }



    /**
     * @see MessageListener#onMessage(Message)
     */
    public void onMessage( Message message ) {
        System.out.println();
        System.out.println( "MessageDriveBeanOSGI.onMessage()" );
        System.out.println( "Received message: " + message );
        ObjectMessage objectMessage = ( ObjectMessage ) message;
        try {
            final Serializable object = objectMessage.getObject();
            System.out.println( "ObjectMessage.getObject(): " + object );
            System.out.println( "MyOSGI instanceof MyOSGI: " + ( object instanceof MyOSGI ) );
            System.out.println( "ObjectMesssage.getObject.getClass().getClassLoader(): " + object.getClass().getClassLoader() );
            System.out.println( "MyOSGI.class.getClassLoader(): " + MyOSGI.class.getClassLoader() );
            final MyOSGI myOSGI = (MyOSGI)object;
            System.out.println( "MyOSGI = " + myOSGI );
        } catch ( Exception e ) {
            e.printStackTrace();
        }

    }

}
